function [layers]=define_layers(imageSize,n_training_categories,style)

% usage:
% [layers]=define_layers(imageSize,n_training_categories,style)

%% Define the convolutional neural network architecture

if (style == 1)
    layers = [ ...
        imageInputLayer(imageSize)
        convolution2dLayer(5,20)
        reluLayer
        maxPooling2dLayer(2,'Stride',2)
        fullyConnectedLayer(n_training_categories)
        softmaxLayer
        classificationLayer];
end
if (style == 2)
    layers = [
        imageInputLayer(imageSize)
        
        convolution2dLayer(3,8,'Padding','same')
        batchNormalizationLayer
        reluLayer
        
        maxPooling2dLayer(2,'Stride',2)
        
        convolution2dLayer(3,16,'Padding','same')
        batchNormalizationLayer
        reluLayer
        
        maxPooling2dLayer(2,'Stride',2)
        
        convolution2dLayer(3,32,'Padding','same')
        batchNormalizationLayer
        reluLayer
        
        fullyConnectedLayer(n_training_categories)
        softmaxLayer
        classificationLayer];
end

if (style == 3)
    layers = [
        imageInputLayer(imageSize)

        convolution2dLayer(3,4,'Padding','same')
        batchNormalizationLayer
        reluLayer

        maxPooling2dLayer(2,'Stride',2)

        convolution2dLayer(3,8,'Padding','same')
        batchNormalizationLayer
        reluLayer
        
        maxPooling2dLayer(2,'Stride',2)
        
        convolution2dLayer(3,16,'Padding','same')
        batchNormalizationLayer
        reluLayer
        
        maxPooling2dLayer(2,'Stride',2)
        
        convolution2dLayer(3,32,'Padding','same')
        batchNormalizationLayer
        reluLayer

        maxPooling2dLayer(2,'Stride',2)

        fullyConnectedLayer(n_training_categories)
        softmaxLayer
        classificationLayer];
end
